library routing.client;
import "package:route_hierarchical/client.dart";
//import 'package:route/pattern.dart';
import 'package:params/client.dart';

Router initRouter(server, clientRoutes) {
  List urls = new List();

  Router router = new Router();
  Route root = router.root;

  String level = "root";
  clientRoutes.forEach((String routeName, Map route) {
    addRootRoute(root, routeName, route);
  });
  
  
  
  
  return router;
}

addRootRoute(root, routeName, route) {
  if (route["defaultRoute"] != null) {
    if (route["enter"] != null) {
      if (route["nested"] != null) {
        root.addRoute(name: routeName, path: route['path'], defaultRoute: route['defaultRoute'], enter: route['action'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        root.addRoute(name: routeName, path: route['path'], defaultRoute: route['defaultRoute'], enter: route['action']);
      }
    } else {//NOT ENTER
      if (route["nested"] != null) {
        root.addRoute(name: routeName, path: route['path'], defaultRoute: route['defaultRoute'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        root.addRoute(name: routeName, path: route['path'], defaultRoute: route['defaultRoute']);
      }
    }
  } else {//NOT DEFAULT ROUTE
    if (route["enter"] != null) {
      if (route["nested"] != null) {
        root.addRoute(name: routeName, path: route['path'], enter: route['action'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        root.addRoute(name: routeName, path: route['path'], enter: route['action']);
      }
    } else {//NOT ENTER
      if (route["nested"] != null) {
        root.addRoute(name: routeName, path: route['path'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        root.addRoute(name: routeName, path: route['path']);
      }
    }
  }
}


addMountRoutes(subRouter, subRoutes) {
  subRoutes.forEach((String subRouteName, Map subRoute) {
    addMountRoute(subRouter, subRouteName, subRoute);
  });
}

addMountRoute(router, routeName, route) {
  if (route["defaultRoute"] != null) {
    if (route["enter"] != null) {
      if (route["nested"] != null) {
        router.addDefaultRoute(name: routeName, path: route['path'], enter: route['action'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        router.addDefaultRoute(name: routeName, path: route['path'], enter: route['action']);
      }
    } else {//NOT ENTER
      if (route["nested"] != null) {
        router.addDefaultRoute(name: routeName, path: route['path'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        router.addDefaultRoute(name: routeName, path: route['path']);
      }
    }
  } else {//NOT DEFAULT ROUTE
    if (route["enter"] != null) {
      if (route["nested"] != null) {
        router.addRoute(name: routeName, path: route['path'], enter: route['action'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        router.addRoute(name: routeName, path: route['path'], enter: route['action']);
      }
    } else {//NOT ENTER
      if (route["nested"] != null) {
        router.addRoute(name: routeName, path: route['path'], mount: (subRouter) => addMountRoutes(subRouter, route["nested"]));
      } else {//NOT NESTED
        router.addRoute(name: routeName, path: route['path']);
      }
    }
  }
}
